// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO20/16AO20_Linux_2.x.x.x_GSC_DN/samples/sbtest/buffer_over_frame.c $
// $Rev: 52761 $
// $Date: 2023-04-05 15:08:50 -0500 (Wed, 05 Apr 2023) $

// 16AO20: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	// There are no persistent bits to test with this service.
	return(0);
}




//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list_1[]	=
	{
		{					// Put the buffer in circular mode.
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_BUFFER_MODE,
			/* arg		*/	AO20_BUFFER_MODE_CIRC,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	list_2[]	=
	{
		// Induce a frame overrun

		{					// Put data in the buffer.
			/* service	*/	SERVICE_REG_MOD,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AO20_GSC_ODBR,
			/* mask		*/	0x0000,
			/* value	*/	0x0000
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	list_3[]	=
	{
		// Clear the status.

		{					// Clear the status.
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_BUFFER_OVER_FRAME,
			/* arg		*/	AO20_BUFFER_OVER_FRAME_CLR,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	s32	_1_no;
	s32	_2_yes;
	s32	_3_no;
	int	errs	= 0;
	int	ret;

	errs	+= ao20_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list_1);
	_1_no	= AO20_BUFFER_OVER_FRAME_CHK;
	ret		= ao20_ioctl(fd, AO20_IOCTL_BUFFER_OVER_FRAME,&_1_no);
	errs	+= ret ? 1 : 0;

	errs	+= service_ioctl_set_reg_list(fd, list_2);
	_2_yes	= AO20_BUFFER_OVER_FRAME_CHK;
	ret		= ao20_ioctl(fd, AO20_IOCTL_BUFFER_OVER_FRAME,&_2_yes);
	errs	+= ret ? 1 : 0;

	errs	+= service_ioctl_set_reg_list(fd, list_3);
	_3_no	= AO20_BUFFER_OVER_FRAME_CHK;
	ret		= ao20_ioctl(fd, AO20_IOCTL_BUFFER_OVER_FRAME,&_3_no);
	errs	+= ret ? 1 : 0;

	if (errs)
	{
	}
	else if (_1_no != AO20_BUFFER_OVER_FRAME_NO)
	{
		errs++;
		printf("FAIL <--- (List 1 results are not NO.)\n");
	}
	else if (_2_yes != AO20_BUFFER_OVER_FRAME_YES)
	{
		errs++;
		printf("FAIL <--- (List 2 results are not YES.)\n");
	}
	else if (_3_no != AO20_BUFFER_OVER_FRAME_NO)
	{
		errs++;
		printf("FAIL <--- (List 3 results are not NO.)\n");
	}

	errs	+= ao20_initialize(fd, -1, 0);
	return(errs);
}




/******************************************************************************
*
*	Function:	buffer_over_frame_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AO20_IOCTL_BUFFER_OVER_FRAME.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int buffer_over_frame_test(int fd)
{
	int	errs	= 0;

	gsc_label("AO20_IOCTL_BUFFER_OVER_FRAME");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


