// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO20/16AO20_Linux_2.x.x.x_GSC_DN/samples/sbtest/load_request.c $
// $Rev: 52761 $
// $Date: 2023-04-05 15:08:50 -0500 (Wed, 05 Apr 2023) $

// 16AO20: Sample Application: source file

#include "main.h"



// variables ******************************************************************

static const service_data_t	data[]	=
{
	{					// Disable the clock.
		/* service	*/	SERVICE_NORMAL,
		/* cmd		*/	AO20_IOCTL_CLOCK_ENABLE,
		/* arg		*/	AO20_CLOCK_ENABLE_NO,
		/* reg		*/	-1,
		/* mask		*/	0,
		/* value	*/	0
	},
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x00000 },
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x01000 },
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x02000 },
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x03000 },
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x04000 },
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x05000 },
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x06000 },
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x07000 },
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x08000 },
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x09000 },
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x0A000 },
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x0B000 },
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x0C000 },
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x0D000 },
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x0E000 },
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x0F000 },
	{ SERVICE_REG_WRITE, 0, 100, AO20_GSC_ODBR, 0, 0x10000 },	// EOF

	{ SERVICE_END_LIST }
};



//*****************************************************************************
static int _service_test(int fd)
{
	// There are no persistent bits to test with this service.
	return(0);
}




//*****************************************************************************
static int _function_test_fail(int fd)
{
	static const service_data_t	list_1[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_CLOCK_OSC_SRC,
			/* arg		*/	AO20_CLOCK_OSC_SRC_ALT,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_NCLK,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_NRATE,
			/* arg		*/	1000,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_DATA_FORMAT,
			/* arg		*/	AO20_DATA_FORMAT_OFF_BIN,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{					// Enable only a single channel.
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_CHANNEL_SEL,
			/* arg		*/	0x1,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{					// Simultaneous outputs mode.
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_OUTPUT_MODE,
			/* arg		*/	AO20_OUTPUT_MODE_SIM,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_BUFFER_SIZE,
			/* arg		*/	AO20_BUFFER_SIZE_4K,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{					// Set the Load Request Timeout.
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_TX_IO_TIMEOUT,
			/* arg		*/	2,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	list_2[]	=
	{
		{					// Select circular mode.
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_BUFFER_MODE,
			/* arg		*/	AO20_BUFFER_MODE_CIRC,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_SLEEP_MS,
			/* cmd		*/	0,
			/* arg		*/	1,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	s32	_1_yes;
	s32	_2_no;
	s32	_3_m1;
	s32	_3_to;
	int	errs	= 0;
	int	ret;

	errs	+= ao20_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, data);

	errs	+= service_ioctl_set_reg_list(fd, list_1);
	ret		= ao20_ioctl(fd, AO20_IOCTL_LOAD_READY,&_1_yes);
	errs	+= ret ? 1 : 0;

	errs	+= service_ioctl_set_reg_list(fd, list_2);
	ret		= ao20_ioctl(fd, AO20_IOCTL_LOAD_READY,&_2_no);
	errs	+= ret ? 1 : 0;

	_3_m1	= ao20_ioctl(fd, AO20_IOCTL_LOAD_REQUEST, NULL);
	_3_to	= _3_m1;

	if (errs)
	{
	}
	else if (_1_yes != AO20_LOAD_READY_YES)
	{
		errs++;
		printf("FAIL <--- (Test 1 results are not YES.)\n");
	}
	else if (_2_no != AO20_LOAD_READY_NO)
	{
		errs++;
		printf("FAIL <--- (Test 2 results are not NO.)\n");
	}
	else if (_3_m1 >= 0)
	{
		errs++;
		printf("FAIL <--- (Test 3 did not fail.)\n");
	}
	else if (_3_to != -ETIMEDOUT)
	{
		errs++;
		printf("FAIL <--- (Test 3 results are not ETIMEDOUT.)\n");
	}

	errs	+= ao20_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test_pass(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_CLOCK_OSC_SRC,
			/* arg		*/	AO20_CLOCK_OSC_SRC_ALT,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_NCLK,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_NRATE,
			/* arg		*/	1000,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_DATA_FORMAT,
			/* arg		*/	AO20_DATA_FORMAT_OFF_BIN,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{					// Enable only a single channel.
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_CHANNEL_SEL,
			/* arg		*/	0x1,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{					// Simultaneous outputs mode.
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_OUTPUT_MODE,
			/* arg		*/	AO20_OUTPUT_MODE_SIM,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_BUFFER_SIZE,
			/* arg		*/	AO20_BUFFER_SIZE_4K,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{					// Set the Load Request Timeout.
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_TX_IO_TIMEOUT,
			/* arg		*/	2,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{					// Select circular mode.
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_BUFFER_MODE,
			/* arg		*/	AO20_BUFFER_MODE_CIRC,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{					// Enable the clock.
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_CLOCK_ENABLE,
			/* arg		*/	AO20_CLOCK_ENABLE_YES,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AO20_IOCTL_LOAD_REQUEST,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;

	errs	+= ao20_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_reg_list(fd, data);
	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= ao20_initialize(fd, -1, 0);
	return(errs);
}




//*****************************************************************************
static int _function_test(int fd)
{
	int	errs	= 0;

	errs	+= _function_test_fail(fd);
	errs	+= _function_test_pass(fd);
	return(errs);
}




/******************************************************************************
*
*	Function:	load_request_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AO20_IOCTL_LOAD_REQUEST.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int load_request_test(int fd)
{
	int	errs	= 0;

	gsc_label("AO20_IOCTL_LOAD_REQUEST");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


